package PScm::SpecialForm;

use strict;
use warnings;
use base qw(PScm::Expr);

##############################
package PScm::SpecialForm::If;

use base qw(PScm::SpecialForm);

sub Apply {
    my ($self, $form) = @_;

    my ($condition, $true_branch, $false_branch) = $form->value;

    if ($condition->Eval()->isTrue) {
        return $true_branch->Eval();
    } else {
        return $false_branch->Eval();
    }
}

1;
